#ifndef bqTulO_hh
#define bqTulO_hh

#include <map>
#include "zero.hh"
#include "autoptr.hh"
#include "elem.hh"

extern bool TuloDebug;

class tulo : public Elem
{
	typedef real         potype;
	typedef num0<potype> pot0;
	
	// Elementti, potenssi	
	typedef map<elemp, pot0> elemap;
	
	friend class Parser;
	friend class summa;
	
	elemap elems;
	
public:
	tulo() : Elem('*')
	{
	}

	inline unsigned size() const { return elems.size(); }
	
	int count(const elemp &p) const
	{
		elemap::const_iterator i = elems.find(p);
		if(i == elems.end())return 0;
		return i->second;
	}
	
	void insert(elemp p, const potype n = 1.0L)
	{
		if(p->type == '*')
		{
			tulo &tmp = *(tulo *)&*p;
			for(elemap::iterator i=tmp.elems.begin(); i!=tmp.elems.end(); ++i)
				elems[i->first] += i->second * n;
			return;
		}
		elems[p] += n;
	}
	inline void erase(elemp p, const potype n = 1.0L) { insert(p, -n); }

	virtual bool operator== (const Elem &e) const;
	virtual bool operator< (const Elem &e) const;

	virtual elemp Expand();
};

typedef autoeqptr<tulo> tulop;

#endif
